;;; Pline_block -Gilles Chanteau- 13/04/07
;;; Insre le bloc "pline_block" aprs slection d'une polyligne
;;; Attribut 1 : Nom de la pice
;;; Attribut 2 : Longueur de la polyligne
;;; Attribut 3 : Aire de la polyligne

(defun c:pline_block (/ AcDoc Space bloc nom ent obj ins op reg ech id long aire ref)
  (vl-load-com)
  (setq	AcDoc (vla-get-ActiveDocument (vlax-get-acad-object))
	Space (if (= (getvar "CVPORT") 1)
		(vla-get-PaperSpace AcDoc)
		(vla-get-ModelSpace AcDoc)
	      )
  )
  (if (or
	(tblsearch "BLOCK" (setq bloc "Pline_block"))
	(findfile (setq bloc "Pline_block.dwg"))
      )
    (progn

      ;; attribut "nom de la pice"
      (if (not (setq nom (getname "Nom de la pice")))
	(setq nom "")
      )

      (while (not (setq ent (car (entsel)))))
      (setq	obj  (vlax-ename->vla-object ent))
      (if (= "AcDbPolyline" (vla-get-ObjectName obj))
	(progn
	  (if (not
		(setq
		  ins
		   (getpoint
		     "\nSpcifiez le point d'insertion ou < Centre >: "
		   )
		)
	      )
	    (progn
	      (if (= (vla-get-closed obj) :vlax-false)
		(progn
		  (vla-put-closed obj :vlax-true)
		  (setq op T)
		)
	      )
	      (setq reg	(vlax-invoke space 'addRegion (list obj))
		    ins	(vlax-get (car reg) 'Centroid)
	      )
	      (if op
		(vla-put-closed obj :vlax-false)
	      )
	      (vla-delete (car reg))
	    )
	  )
	  (if (not (vlax-ldata-get "Pline_block" "ech"))
	    (vlax-ldata-put "Pline_block" "ech" 1)
	  )
	  (if (not (setq
		     ech
		      (getreal
			(strcat	"\nEntrez le facteur d'chelle <"
				(rtos (vlax-ldata-get "Pline_block" "ech"))
				">: "
			)
		      )
		   )
	      )
	    (setq ech (vlax-ldata-get "Pline_block" "ech"))
	    (vlax-ldata-put "Pline_block" "ech" ech)
	  )
	  (setq	id   (vla-get-ObjectID obj)

		;; Attribut primtre (mm -> m)
		long (strcat "%<\\AcObjProp Object(%<\\_ObjId "
			     (itoa id)
			     ">%).Length \\f \"%lu2%pr2%ct8[0.001]\">%"
		     )

		;; Attribut surface (mm -> m)
		aire (strcat "%<\\AcObjProp Object(%<\\_ObjId "
			     (itoa id)
			     ">%).Area \\f \"%lu2%pr2%ct8[1e-006]\">%"
		     )
	  )

	  (setq	ref
		 (vla-InsertBlock
		   Space
		   (vlax-3d-point (trans ins 1 0))
		   bloc
		   ech
		   ech
		   1
                   (angle '(0 0 0) (trans (getvar 'ucsxdir) 0 (trans '(0 0 1) 1 0 T)))
		 )
	  )

	  ;; attribution de leur valeur aux attributs
	  (mapcar '(lambda (x y) (vla-put-TextString x y))
		  (vlax-invoke ref 'GetAttributes)
		  (list nom long aire)
	  )

	  (vla-regen AcDoc acActiveViewport)
	)
	(alert "L'objet slectionn n'est pas une polyligne.")
      )
    )
    (alert "Le bloc \"Pline_block\" est introuvable.")
  )
  (princ)
)