(defun bs:triangleArea ( coords / longueurs a b c )
; Argument : une liste de 3 points, chaque point tant une liste de 2 ou 3 coordonnes
; Retour : la surface du triangle (nombre rel)

  (setq longueurs (cons (distance (car coords) (cadr coords)) longueurs)
        longueurs (cons (distance (cadr coords) (caddr coords)) longueurs)
        longueurs (cons (distance (caddr coords) (car coords)) longueurs)
        longueurs (bs:sort longueurs '>); tri dcroissant
  )
  (apply '(lambda (a b c) (/ (sqrt (* (+ a b c) (- c (- a B)) (+ c (- a B)) (+ a (- b c)) ) ) 4.0)) longueurs)
)

(defun bs:sort ( l fun / )
; fonctionne comme vl-sort, mais sans supprimer les doublons de la liste
  (mapcar '(lambda (x) (apply 'nth (list x l))) (vl-sort-i l fun))
)

(defun c:3DFAREA ( / ss i f aire )
  (setq ss (ssget '((0 . "3DFACE"))))
  (if ss
    (progn
      (setq i 0
            aire 0.0)
      (repeat (sslength ss)
        (setq f (entget (ssname ss i))
              aire (+ aire (bs:triangleArea (list (cdr (assoc 10 f)) (cdr (assoc 11 f)) (cdr (assoc 12 f)))))
              i (1+ i))
      );repeat
      (prompt (strcat "\n" (itoa i) " faces 3D traites, aire totale : " (rtos aire 2 8)))
    );progn
  );if
  (princ)
)