;;;=================================================================
;;;
;;; GEF.LSP V1.10
;;;
;;; Gerer les calques des fentres dans les prsentations
;;;
;;; Copyright (C) Patrick_35
;;;
;;;=================================================================

(defun c:gef(/	aff cal cmd cod dcl doc fen grp i lay lst n obj old pre par prt reg sau sel_cal sel_fen tbl typ val vie
		affichage_calques gerer_fenetres MsgBox selection)

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Message
  ;;;
  ;;;---------------------------------------------------------------

  (defun MsgBox (Titre Bouttons Message / Reponse WshShell)
    (vl-load-com)  
    (setq WshShell (vlax-create-object "WScript.Shell"))
    (setq Reponse  (vlax-invoke WshShell 'Popup Message 0 Titre (itoa Bouttons)))
    (vlax-release-object WshShell)
    Reponse
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Griser ou pas les boutons geler/afficher
  ;;;
  ;;;---------------------------------------------------------------

  (defun selection()
    (and sel_fen
	 sel_cal
      (progn
	(mode_tile "gel" 0)
	(mode_tile "aff" 0)
      )
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Afficher l'tat des calques
  ;;;
  ;;;---------------------------------------------------------------

  (defun affichage_calques(sel / js lst n mar tab tot val)
    (setq sel_fen sel
	  lst (list)
	  tot 0
    )
    (selection)
    (while (not (eq sel ""))
      (setq val (read sel)
	    lst (append lst (nth val aff))
	    sel (substr sel (+ 2 (strlen (itoa val))) (strlen sel))
	    tot (1+ tot)
      )
    )
    (while lst	
      (setq n   (length lst)
	    js  (car lst)
	    lst (vl-remove js lst)
	    tab (cons (cons js (- n (length lst))) tab)
      )
    )
    (setq n 0)
    (start_list "cal")
    (while (setq val (nth n cal))
      (if (setq js (assoc val tab))
	(if (eq (cdr js) tot)
	  (setq mar "G")
	  (setq mar "M")
	)
	(setq mar "A")
      )
      (add_list (strcat mar "   " val))
      (setq n (1+ n))
    )
    (end_list)
    (and sel_cal
      (set_tile "cal" sel_cal)
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Mise  jour de l'affichage de l'tat des calques suivant
  ;;; l'action de l'utilisateur sur les boutons afficher/geler
  ;;;
  ;;;---------------------------------------------------------------

  (defun gerer_fenetres(typ / lst n par sel val)
    (setq sel sel_cal)
    (while (not (eq sel ""))
      (setq val (read sel)
	    lst (cons (nth val cal) lst)
	    sel (substr sel (+ 2 (strlen (itoa val))) (strlen sel))
      )
      (start_list "cal" 1 val)
      (if typ
	(add_list (strcat "G   " (nth val cal)))
	(add_list (strcat "A   " (nth val cal)))
      )
      (end_list)
    )
    (setq sel sel_fen)
    (while (not (eq sel ""))
      (setq val (read sel)
	    n (1+ val)
	    par (nth val aff)
      )
      (foreach ele lst
	(if typ
	  (or (member ele par)
	    (setq par (cons ele par))
	  )
	  (and (member ele par)
	    (setq par (vl-remove ele par))
	  )
	)
      )
      (setq aff (mapcar '(lambda(x) (if (zerop (setq n (1- n))) par x)) aff)
	    sel (substr sel (+ 2 (strlen (itoa val))) (strlen sel))
      )
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Rourine principale
  ;;;
  ;;;---------------------------------------------------------------

  (setq doc (vla-get-activedocument (vlax-get-acad-object))
	n 1
  )
  (vla-startundomark doc)
  (if (setq dcl (findfile "gef.dcl"))
    (progn
      (vlax-for lay (vla-get-layouts doc)
	(setq lst (cons (list (vla-get-taborder lay) (vla-get-name lay)) lst)
	      vie nil
	      sau nil
	)
	(vlax-for ent (vla-get-block lay)
	  (if (and sau
		   (eq (vla-get-objectname ent) "AcDbViewport")
	      )
	    (setq vie (cons ent vie))
	    (setq sau T)
	  )
	)
	(and vie
	  (setq fen (cons (list (vla-get-name lay) (reverse vie)) fen))
	)
      )
      (repeat (1- (length lst))
	(setq tbl (cons (list (cadr (assoc n lst))
			      (cadr (assoc (cadr (assoc n lst)) fen))
			)
			tbl
		  )
	)
	(setq n (1+ n))
      )
      (vlax-for lay (vla-get-layers doc)
	(setq cal (cons (vla-get-name lay) cal))
      )
      (setq cal (acad_strlsort cal)
	    tbl (reverse tbl)
	    dcl (load_dialog dcl)
      )
      (new_dialog "gef" dcl "")
      (set_tile "titre" "GEF V1.00")
      (start_list "fen")
      (foreach obj tbl
	(setq lst nil)
	(foreach lay (cadr obj)
	  (add_list (strcat (car obj) " ---> " (rtos (vla-get-width lay)) " x " (rtos (vla-get-height lay))))
	  (vla-getxdata lay "" 'cod 'typ)
	  (setq cod (vlax-safearray->list cod)
		typ (vlax-safearray->list typ)
		grp nil
		n 0
	  )
	  (while (setq val (nth n cod))
	    (and (eq val 1003)
	      (setq grp (cons (vlax-variant-value (nth n typ)) grp))
	    )
	    (setq n (1+ n))
	  )
	  (if grp
	    (setq lst (cons grp lst))
	    (setq lst (cons '(nil) lst))
	  )
	)
	(if lst
	  (setq aff (append aff (reverse lst)))
	  (setq aff (append aff '(nil)))
	)
      )
      (end_list)
      (start_list "cal")
      (mapcar '(lambda(x)(add_list (strcat "X   " x))) cal)
      (end_list)
      (set_tile "txt1" "Lgende : Nom de l'onglet ---> Taille de la fentre")
      (set_tile "txt2" "Lgende : A = Affich      G=Gel      M = Mlang      X = Pas encore de slection")
      (mode_tile "gel" 1)
      (mode_tile "aff" 1)
      (action_tile "fen"    "(affichage_calques $value)")
      (action_tile "cal"    "(setq sel_cal $value)(selection)")
      (action_tile "gel"    "(gerer_fenetres T)")
      (action_tile "aff"    "(gerer_fenetres nil)")
      (action_tile "accept" "(done_dialog 1)")
      (action_tile "cancel" "(done_dialog 0)")
      (and (eq (start_dialog) 1)
	(progn
	  (setq old (vla-get-activelayout doc)
		n 0
	  )
	  (foreach pre tbl
	    (foreach vie (cadr pre)
	      (vla-getxdata vie "" 'cod 'typ)
	      (setq cod (vlax-safearray->list cod)
		    typ (vlax-safearray->list typ)
		    par (nth n aff)
		    lst nil
		    cal nil
		    i 0
	      )
	      (while (setq val (nth i cod))
		(and (eq val 1003)
		  (setq cal (cons (vlax-variant-value (nth i typ)) cal))
		)
		(setq i (1+ i))
	      )
	      (foreach ele par
		(and ele
		     (not (member ele cal))
		  (setq lst (cons (cons ele 0) lst))
		)
	      )
	      (foreach ele cal
		(or (member ele par)
		  (setq lst (cons (cons ele 1) lst))
		)
	      )
	      (and lst
		(progn
		  (or (eq (vla-get-objectid (vla-get-activelayout doc)) (vla-get-objectid (setq lay (vla-item (vla-get-layouts doc) (car pre)))))
		    (vla-put-activelayout doc lay)
		  )
		  (setq cmd (getvar "cmdecho")
			reg (getvar "regenmode")
		  )
		  (setvar "cmdecho" 0)
		  (setvar "regenmode" 0)
		  (foreach cal lst
		    (if (eq (cdr cal) 0)
		      (setq val "_freeze")
		      (setq val "_thaw")
		    )
		    (vl-cmdf "_.vplayer" val (car cal) "_select" (vlax-vla-object->ename vie) "" "")
		  )
		  (setvar "regenmode" reg)
		  (setvar "cmdecho" cmd)
		)
	      )
	      (setq n (1+ n))
	    )
	  )
	  (or (eq (vla-get-objectid (vla-get-activelayout doc)) (vla-get-objectid old))
	    (vla-put-activelayout doc old)
	  )
	)
      )
      (unload_dialog dcl)
    )
    (msgbox "GEF" 16 "Fichier GEF.DCL introuvable")
  )
  (vla-endundomark doc)
  (princ)
)

(setq nom_lisp "GEF")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " charg."))
    (princ (strcat "\n" nom_lisp ".LSP Charg.....Tapez " nom_lisp " pour l'xecuter.")))
  (princ (strcat "\n" nom_lisp ".LSP Charg......Tapez " nom_lisp " pour l'xecuter.")))
(setq nom_lisp nil)
(princ)