;;;=================================================================
;;;
;;; MAT V5.02
;;;
;;; Mettre tous les attributs  la mme valeur
;;;
;;; Copyright (C) Patrick_35
;;;
;;;=================================================================

(defun c:mat(/ bl choix dcl_id doc js ent liste_bl liste_att n nom_bloc old_error posbl posat resultat sel tot val_at *errmat* MsgBox modif_at rech_at affiche affiche_va rech_bl rech_blat)

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Gestion des erreurs
  ;;;
  ;;;---------------------------------------------------------------

  (defun *errmat* (msg)
    (or (member (strcase msg) '("FUNCTION CANCELLED" ""QUIT / EXIT ABORT"" "FONCTION ANNULEE" "QUITTER / SORTIR ABANDON"))
      (princ (strcat "\nErreur : " msg))
    )
    (setq *error* old_error)
    (unload_dialog dcl_id)
    (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
    (princ)
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Afficher un message
  ;;;
  ;;;---------------------------------------------------------------

  (defun MsgBox (Titre Bouttons Message / Reponse WshShell)
    (setq WshShell (vlax-create-object "WScript.Shell"))
    (setq Reponse  (vlax-invoke WshShell 'Popup Message 7 Titre (itoa Bouttons)))
    (vlax-release-object WshShell)
    Reponse
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Rechercher les attributs d'un bloc
  ;;;
  ;;;---------------------------------------------------------------

  (defun rech_at(nom / at bl tb)
    (setq bl (vla-item (vla-get-blocks doc) nom))
    (vlax-for at bl
      (and (eq (vla-get-objectname at) "AcDbAttributeDefinition")
	(if (eq (vla-get-constant at) :vlax-true)
	  (setq tb (cons (list (vla-get-tagstring at)) tb))
	  (setq tb (cons
		     (cons (vla-get-tagstring at)
			   (if (eq (vla-get-promptstring at) "")
			     (vla-get-tagstring at)
			     (vla-get-promptstring at)
			   )
		     )
		     tb
		   )
	  )
	)
      )
    )
    (reverse tb)
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Afficher les attributs d'un bloc
  ;;;
  ;;;---------------------------------------------------------------

  (defun affiche(/ val)
    (if (setq liste_at (rech_at (nth (atoi posbl) liste_bl)))
      (progn
	(foreach val (list "txtat" "listeat" "txtva" "valeur" "accept" "sel" "nou" "pre" "suf")
	  (mode_tile val 0)
	)
	(start_list "listeat")
	(mapcar '(lambda (x) (if (cdr x)
			       (add_list (cdr x))
			       (add_list (strcat "Constant-->" (car x)))
			     )
		 ) liste_at)
	(end_list)
	(affiche_va)
      )
      (foreach val (list "listeat" "txtva" "valeur" "accept" "sel" "nou" "pre" "suf")
	(mode_tile val 1)
      )
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Griser si attribut constant
  ;;;
  ;;;---------------------------------------------------------------

  (defun affiche_va()
    (mode_tile "valeur" 0)
    (mode_tile "accept" 0)
    (or (cdr (nth (atoi posat) liste_at))
      (progn
	(mode_tile "valeur" 1)
	(mode_tile "accept" 1)
      )
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Modifier le texte de l'attribut
  ;;;
  ;;;---------------------------------------------------------------

  (defun modif_at(ent / lst att)
    (and (eq nom_bloc
	     (if (vlax-property-available-p ent 'effectivename)
	       (vla-get-effectivename ent)
	       (vla-get-name ent)
	     )
	 )
	 (not (eq (cdr (nth (atoi posat) liste_at)) ""))
      (progn
	(setq lst (vlax-invoke ent 'getattributes)
	      att (nth (atoi posat) lst)
	      tot (1+ tot)
	)
	(cond
	  ((eq choix "nou")
	    (vla-put-textstring att val_at)
	  )
	  ((eq choix "pre")
	    (vla-put-textstring att (strcat val_at (vla-get-textstring att)))
	  )
	  (T
	    (vla-put-textstring att (strcat (vla-get-textstring att) val_at))
	  )
	)
      )
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Slection d'un bloc pour rcuperer son nom
  ;;;
  ;;;---------------------------------------------------------------

  (defun rech_bl(/ lst nom sel)
    (defun nom(val)
      (setq val (vlax-ename->vla-object val))
      (if (vlax-property-available-p val 'effectivename)
	(vla-get-effectivename val)
	(vla-get-name val)
      )
    )

    (and (setq sel (entsel "\nVeuillez slectionner un bloc : "))
	 (eq (cdr (assoc 0 (entget (car sel)))) "INSERT")
	 (setq lst (member (nom (car sel)) liste_bl))
	 (setq posbl (itoa (- (length liste_bl) (length lst))))
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Slection d'un attribut pour rcuperer son tiquette et le nom du bloc
  ;;;
  ;;;---------------------------------------------------------------

  (defun rech_blat(/ att bl lst sel)
    (and (setq sel (nentsel "\nVeuillez slectionner un attribut : "))
	 (eq (vla-get-objectname (setq att (vlax-ename->vla-object (car sel)))) "AcDbAttribute")
	 (not (vl-catch-all-error-p (setq bl (vl-catch-all-apply 'vla-objectidtoobject (list (vla-get-database att) (vla-get-ownerid att))))))
	 (setq lst (member 
		     (if (vlax-property-available-p bl 'effectivename)
		       (vla-get-effectivename bl)
		       (vla-get-name bl)
		     )
		     liste_bl
		   )
	 )
	 (setq posbl (itoa (- (length liste_bl) (length lst))) posat "0")
	 (setq liste_att (rech_at (vla-get-name bl)))
	 (setq lst (mapcar 'vla-get-objectid (vlax-invoke bl 'getattributes)))
	 (setq posat (itoa (- (length lst) (length (member (vla-get-objectid att) lst)))))
    )
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Routine principale.
  ;;;
  ;;;---------------------------------------------------------------

  (vl-load-com)
  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (setq Old_Error *error* *error* *errmat* doc (vla-get-activedocument (vlax-get-acad-object)))
  (if (findfile "Mat.dcl")
    (progn
      (vlax-for bl (vla-get-blocks doc)
	(or (wcmatch (vla-get-name bl) "`**,*|*")
	  (eq (vla-get-isxref bl) :vlax-true)
	  (setq liste_bl (cons (vla-get-name bl) liste_bl))
	)
      )
      (if liste_bl
	(progn
	  (setq dcl_id (load_dialog (findfile "Mat.dcl"))
		liste_bl (acad_strlsort liste_bl)
		val_at ""
		posbl "0"
		posat "0"
		choix "nou")
	  (while (and (/= resultat 0)
		      (/= resultat 1)
		 )
	    (new_dialog "mat" dcl_id)
	    (set_tile "titre" "MAT V5.02")
	    (set_tile choix "1")
	    (affiche)
	    (mode_tile "cancel" 2)
	    (start_list "listebl")
	    (mapcar 'add_list liste_bl)
	    (end_list)
	    (set_tile "listebl" posbl)
	    (and liste_att
	      (set_tile "listeat" posat)
	    )
	    (action_tile "listebl" "(setq posbl $value)(affiche)")
	    (action_tile "chbl"	   "(done_dialog 2)")
	    (action_tile "listeat" "(setq posat $value)(affiche_va)")
	    (action_tile "chat"	   "(done_dialog 3)")
	    (action_tile "valeur"  "(setq val_at $value)")
	    (action_tile "sel"	   "(setq sel $value)")
	    (action_tile "nou"	   "(setq choix \"nou\")")
	    (action_tile "pre"	   "(setq choix \"pre\")")
	    (action_tile "suf"	   "(setq choix \"suf\")")
	    (action_tile "cancel"  "(done_dialog 0)")
	    (action_tile "accept"  "(done_dialog 1)")
	    (setq resultat (start_dialog))
	    (cond
	      ((eq resultat 1)
		(setq nom_bloc (nth (atoi posbl) liste_bl)
		      tot 0
		)
		(if liste_at
		  (if (if (eq sel "1")
			(ssget (list (cons 0 "INSERT") (cons 2 (strcat nom_bloc ",`*U*"))))
			(ssget "x" (list (cons 0 "INSERT") (cons 2 (strcat nom_bloc ",`*U*"))))
		      )
		    (progn
		      (vlax-map-collection (setq js (vla-get-activeselectionset doc)) 'modif_at)
		      (princ (strcat "\nModification de " (itoa tot) " bloc(s)"))
		      (vla-delete js)
		    )
		    (if (eq sel "0")
		      (msgbox "MAT" 48 (strcat "Pas de bloc " nom_bloc " dans le dessin"))
		    )
		  )
		  (msgbox "MAT" 48 "Bloc sans attribut")
		)
	      )
	      ((eq resultat 2)
		(rech_bl)
	      )
	      ((eq resultat 3)
		(rech_blat)
	      )
	    )
	  )
	  (unload_dialog dcl_id)
	)
	(msgbox "MAT" 48 "Pas de bloc dans le dessin")
      )
    )
    (msgbox "MAT" 16 "Le fichier MAT.DCL est introuvable.")
  )
  (setq *error* Old_Error)
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (princ)
)

(setq nom_lisp "MAT")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " charg."))
    (princ (strcat "\n" nom_lisp ".LSP Charg.....Tapez " nom_lisp " pour l'xecuter.")))
  (princ (strcat "\n" nom_lisp ".LSP Charg......Tapez " nom_lisp " pour l'xecuter.")))
(setq nom_lisp nil)
(princ)