;;; PolyFillet -Gilles Chanteau- 23/10/2008
;;; Cre un raccord sur les polylignes
;;; Permet de raccorder des segments spars par plusieurs segments
;;; Permet de clore en prolongeant les segments slectionns

(defun c:PolyFillet (/ *error* HighlightSegment
PolyFillet mult rad seg1
pline par1
)




(vl-load-com)

;;;*************************************************************;;;

(defun *error* (msg)
(or (= msg "Fonction annule")
(princ (strcat "Erreur : " msg))
)
(vla-EndUndoMark
(vla-get-ActiveDocument (vlax-get-acad-object))
)
(redraw)
(princ)
)

;;;*************************************************************;;;

(defun HighlightSegment (pl par / p1 p2 n lst)
(and
(setq p1 (vlax-curve-getPointAtParam pl par))
(setq p1 (trans p1 0 1))
(setq p2 (vlax-curve-getPointAtParam pl (+ par 1)))
(setq p2 (trans p2 0 1))
(grvecs (list -255 p1 p2))
)
)

;;;*************************************************************;;;

(defun PolyFillet (/ seg1 plst n sw ew swlst ewlst
blst nlst seg2 par2 tmp closed a
b c d s cw ang dist na
nb nc nd
)
(setq plst (2d-coord->pt-lst (vlax-get pline 'Coordinates)))
(setq n (1- (length plst)))
(while (<= 0 n)
(vla-getWidth pline n 'sw 'ew)
(setq blst (cons (vla-GetBulge pline n) blst)
swlst (cons sw swlst)
ewlst (cons ew ewlst)
n (1- n)
)
)
(and (= (vla-get-Closed pline) :vlax-true)
(setq closed T)
(setq plst (append plst (list (car plst))))
)
(if (zerop (nth par1 blst))
(progn
(HighlightSegment pline par1)
(if
(and
(setq seg2
(entsel "\nSlectionnez le second segment: ")
)
(equal pline (vlax-ename->vla-object (car seg2)))
(setq par2 (fix (vlax-curve-getParamAtPoint
pline
(trans (osnap (cadr seg2) "_nea") 1 0)
)
)
)
(/= par1 par2)
)
(if (zerop (nth par2 blst))
(progn
(redraw)
(vla-StartUndoMark
(vla-get-ActiveDocument (vlax-get-acad-object))
)
(and (< par2 par1)
(setq tmp par1
par1 par2
par2 tmp
)
)
(setq a (nth par1 plst)
b (nth (1+ par1) plst)
c (nth par2 plst)
d (nth (1+ par2) plst)
)
(if (setq s (inters a b c d nil))
(progn
(cond
((and (equal (vec1 a b) (vec1 a s) 1e-9)
(equal (vec1 d c) (vec1 d s) 1e-9)
)
(setq cw (clockwise-p a s d)
ang (/ (ang<2pi
(if cw
(- (angle d c) (angle a b))
(- (angle a b) (angle d c))
)
)
2.0
)
dist (/ (* rad (cos ang)) (sin ang))
nb (polar s (angle b a) dist)
nc (polar s (angle c d) dist)
plst (append (sublist plst 0 (1+ par1))
(list nb nc)
(sublist plst (1+ par2) nil)
)
swlst (append (sublist swlst 0 (1+ par1))
(list (nth par1 ewlst))
(sublist swlst par2 nil)
)
ewlst (append (sublist ewlst 0 (1+ par1))
(list (nth (+ 2 par1) swlst))
(sublist ewlst par2 nil)
)
ang (/ (- (/ pi 2) ang) 2.0)
blst (append
(sublist blst 0 (1+ par1))
(list
(if cw
(- (/ (sin ang) (cos ang))
)
(/ (sin ang) (cos ang))
)
)
(sublist blst par2 nil)
)
)
(and closed
(setq plst (reverse (cdr (reverse plst))))
)
(vlax-put pline
'Coordinates
(apply 'append plst)
)
(setq n 0)
(mapcar
(function
(lambda (x1 x2 x3)
(vla-setBulge pline n x1)
(vla-setWidth pline n x2 x3)
(setq n (1+ n))
)
)
blst
swlst
ewlst
)
(vla-update pline)
)
((and (equal (vec1 b a) (vec1 b s) 1e-9)
(equal (vec1 c d) (vec1 c s) 1e-9)
)
(setq cw (clockwise-p c s b)
ang (/ (ang<2pi
(if cw
(- (angle b a) (angle c d))
(- (angle c d) (angle b a))
)
)
2.0
)
dist (/ (* rad (cos ang)) (sin ang))
na (polar s (angle a b) dist)
nd (polar s (angle d c) dist)
plst (append
(list na)
(sublist plst
(1+ par1)
(- par2 par1)
)
(list nd)
)
swlst (append
(sublist swlst
par1
(if closed
(- par2 par1 -2)
(- par2 par1 -1)
)
)
(list (nth par2 ewlst))
)
ewlst (append
(sublist ewlst
par1
(if closed
(- par2 par1 -2)
(- par2 par1 -1)
)
)
(list (car swlst))
)
ang (/ (- (/ pi 2) ang) 2.0)
blst (append
(sublist blst par1 (- par2 par1 -1))
(list
(if cw
(- (/ (sin ang) (cos ang))
)
(/ (sin ang) (cos ang))
)
)
)
)
(vlax-put pline
'Coordinates
(apply 'append plst)
)
(vla-put-Closed pline :vlax-true)
(setq n 0)
(mapcar
(function
(lambda (x1 x2 x3)
(vla-setBulge pline n x1)
(vla-setWidth pline n x2 x3)
(setq n (1+ n))
)
)
blst
swlst
ewlst
)
(vla-update pline)
)
(T (princ "\nSegments divergents"))
)
)
(princ "\nSegments parallles")
)
(vla-EndUndoMark
(vla-get-ActiveDocument (vlax-get-acad-object))
)
)
(princ "\nSegment non rectiligne.")
)
(progn
(redraw)
(princ "\nSlection non valide.")
)
)
)
(princ "\nSegment non rectiligne.")
)
(if mult
(if
(setq seg1
(entsel
"\nSlectionnez un premier segment de polyligne: "
)
)
(if
(not
(and
(equal pline (vlax-ename->vla-object (car seg1)))
(setq par1 (fix (vlax-curve-getParamAtPoint
pline
(trans (osnap (cadr seg1) "_nea") 1 0)
)
)
)
)
)
(princ "\nSlection non valide.")
)
)
)
)

;;;*************************************************************;;;

(setq rad (getvar "FILLETRAD"))
(princ (strcat "\nParamtre courant\tRayon = " (rtos rad)))
(while (not (vl-consp seg1))
(initget 1 "Multiple Rayon")
(setq seg1
(entsel
"\nSlectionnez un premier segment de polyligne ou [Multiple/Rayon]: "
)
)
(cond
((= seg1 "Multiple") (setq mult T))
((= seg1 "Rayon")
(if (setq
rad (getdist (strcat "\nSpcifiez le rayon du raccord <"
(rtos rad)
">: "
)
)
)
(setvar "FILLETRAD" rad)
(setq rad (getvar "FILLETRAD"))
)
)
)
)
(if
(and
(setq pline (vlax-ename->vla-object (car seg1)))
(= (vla-get-ObjectName pline) "AcDbPolyline")
(setq par1 (fix (vlax-curve-getParamAtPoint
pline
(trans (osnap (cadr seg1) "_nea") 1 0)
)
)
)
)
(if mult
(progn
(setvar "ERRNO" 0)
(while (/= (Getvar "ERRNO") 52) (PolyFillet))
)
(PolyFillet)
)
(princ "\nSlection non valide.")
)
(princ)
)

;;;********************** SOUS ROUTINES ************************;;;

;;; 2d-coord->pt-lst
;;; Convertit une liste de coordonnes 2D en liste de points 2D
;;; (2d-coord->pt-lst '(1.0 2.0 3.0 4.0)) -> ((1.0 2.0) (3.0 4.0))

(defun 2d-coord->pt-lst (lst)
(if lst
(cons (list (car lst) (cadr lst))
(2d-coord->pt-lst (cddr lst))
)
)
)

;;;*************************************************************;;;

;;; VEC1
;;; Retourne le vecteur norm (1 unit) de sens p1 p2
;;;
;;; Arguments : deux points

(defun vec1 (p1 p2)
((lambda (d)
(if (not (zerop d))
(mapcar (function (lambda (x1 x2) (/ (- x2 x1) d))) p1 p2)
)
)
(distance p1 p2)
)
)

;;;*************************************************************;;;

;;; Clockwise-p
;;; Retourne T si les points p1 p2 et p3 tournent dans le sens horaire

(defun clockwise-p (p1 p2 p3)
(< (sin (- (angle p1 p3) (angle p1 p2))) -1e-14)
)

;;;*************************************************************;;;

;;; Ang<2pi
;;; Retourne l'angle,  2*k*pi prs, compris entre 0 et 2*pi

(defun ang<2pi (ang)
(if (and (<= 0 ang) (< ang (* 2 pi)))
ang
(ang<2pi (rem (+ ang (* 2 pi)) (* 2 pi)))
)
)

;;;*************************************************************;;;

;;; SUBLIST
;;; Retourne une sous-liste
;;;
;;; Arguments
;;; lst : une liste
;;; start : l'index de dpart de la sous liste (premier lment = 0)
;;; leng : la longueur (nombre d'lments) de la sous-liste (ou nil)
;;;
;;; Exemples :
;;; (sublist '(1 2 3 4 5 6) 2 2) -> (3 4)
;;; (sublist '(1 2 3 4 5 6) 2 nil) -> (3 4 5 6)

(defun sublist (lst start leng / n r)
(if (or (not leng) (< (- (length lst) start) leng))
(setq leng (- (length lst) start))
)
(setq n (+ start leng))
(while (< start n)
(setq r (cons (nth (setq n (1- n)) lst) r))
)
) 