;|
RemoveSolid
Supprime les applats dans le dessin et les blocs

Lisp  argument, lancer la commande entre paranthse comme dans les exemples

Arugument
flag : la somme des codes binaires suivant :
1  Hachures SOLID
2  solides 2d
4  wipeouts
exemples :
(RemoveSolids 1) ; ne supprime que les hachures SOLID
(RemoveSolids 2) ; ne supprime que les solides 2d
(RemoveSolids 3) ; supprime les hachures SOLID et les solides 2d
(RemoveSolids 4) ; ne supprime que les wipeouts
(RemoveSolids 5) ; supprime les hachures SOLID et les wipeouts
(RemoveSolids 6) ; supprime les solides 2d et les wipeouts
(RemoveSolids 7) ; supprime les hachures SOLID, les solides 2d et les wipeouts

|;

(defun RemoveSolids (flag / *error*)
  (vl-load-com)
  (or *acad* (setq *acad* (vlax-get-acad-object)))
  (or *acdoc* (setq *acdoc* (vla-get-ActiveDocument *acad*)))
  (or *block* (setq *blocks* (vla-get-Blocks *acdoc*)))
  (or *layers* (setq *layers* (vla-get-Layers *acdoc*)))

  (defun *error* (msg)
    (and
      msg
      (/= msg "Fonction annule")
      (princ (strcat "\nErreur: " msg))
    )
    (vla-EndUndoMark *acdoc*)
    (princ)
  )

  (vla-StartUndoMark *acdoc*)
  (vlax-for blk *blocks*
    (vlax-for obj blk
      (if
        (and
          (= (vla-get-Lock (vla-Item *layers* (vla-get-Layer obj)))
             :vlax-false
          )
          (or
            (and
              (= (logand flag 1) 1)
              (= (vla-get-ObjectName obj) "AcDbHatch")
              (wcmatch (strcase (vla-get-PatternName obj)) "*SOLID")
            )
            (and
              (= (logand flag 2) 2)
              (= (vla-get-ObjectName obj) "AcDbSolid")
            )
            (and
              (= (logand flag 4) 4)
              (= (vla-get-ObjectName obj) "AcDbWipeout")
            )
          )
        )
         (vla-delete obj)
      )
    )
  )
  (*error* nil)
)

