;;------------------------------------------------------------------------------
;;Trac d'un talus aprs saisie du type
;;Didier DUHEM 23/03/95  modifie 21/11/98
;;E.Mail D.Duhem@wanadoo.fr
;; http://perso.wanadoo.fr/didier.duhem/outils.htm
;;-------------------------------------------------------------------------------

 
;;---Dbut---------------------------------------------------PutVar--------------
;; << change une variable systme et mmorise l'ancienne valeur                >>
;; <<                                                                          >>
;;
;;  cre le :  mercredi 25 novembre 1998   23:52
;;
;; Admet : 
;; =======
;;   vari       : Chaine   = variable systme
;;   valeur     : Entier   = valeur  placer
;;
;; Retourne : Entier = ancienne valeur
;; ==========
;-------------------------------------------------------------------------------
(Defun PutVar ( vari valeur / tmp)
   (setq tmp (getvar vari))
   (setvar vari valeur)
   tmp 
)
;;---fin-----------------------------------------------------PutVar--------------


;;---Dbut---------------------------------------------------tal_puis2-----------
;; <<nombre de puissances de deux dans un nombre :                              >>
;; << (tal_puis2 48) donne 4 : 2*2*2*2*3                                        >>
;;
;;  cre le :  samedi 21 novembre 1998   16:41
;;
;; Admet : 
;; =======
;;   n          : Entier   = 
;;
;; Retourne : Entier = nombre de puissances de 2
;; ==========
;-------------------------------------------------------------------------------
(Defun tal_puis2 ( n / i)
  (setq i 0)
  (if (/= n 0)
    (while (zerop (rem n 2))
      (setq n (lsh n -1) i (1+ i))
    )
  ) 
  i 
)
;;---fin-----------------------------------------------------tal_puis2-----------


 
;;---Dbut---------------------------------------------------tal_serie-----------
;; << ;;calcul d'une srie kn (1 + k + k +.....+k (n-1))                      >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   16:43
;;
;; Admet : 
;; =======
;;   k          : Entier   = paramtre 
;;   n          : Entier   = puissance
;;
;; Retourne : Entier = 
;; ==========
;-------------------------------------------------------------------------------
(Defun tal_serie ( k n /  s i)
  (setq s 0 i 0)
  (if (/= n 0)
    (while (> n i)
      (setq s (+ s (expt k i))
            i (1+ i)
      )
    )
  )
  s
)
;;---fin-----------------------------------------------------tal_serie-----------



;;---Dbut---------------------------------------------------tal_affiche_image---
;; << ;;affiche le slide relatif  une image avec ventuellement un bord       >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   16:45
;;
;; Admet : 
;; =======
;;   num        : chaine   = "1" ou "2" ou "3" :numro du slide
;;   bord       : Boolen  = T si slide  encadrer
;;
;; Retourne : Entier = 
;; ==========
;-------------------------------------------------------------------------------
(Defun tal_affiche_image ( num bord /  X Y imag nf)
   (setq nf (findfile (strcat "STTALUS" num ".sld")))
   (setq imag (strcat "ima"  num))
   (setq X (dimx_tile imag) Y (dimy_tile imag))
   (start_image imag)
   (if bord
     (progn
      (fill_image 0 0 X Y 1)
      (fill_image 3 3 (- X 6) (- Y 6) 0)
      (if nf (slide_image 3 3 (- X 6) (- Y 6) nf)) 
     )
     (progn
        (fill_image 0 0 X Y 0)
        (if nf (slide_image 3 3 (- X 6) (- Y 6) nf)) 
     )
   )
   (end_image)
)
;;---fin-----------------------------------------------------tal_affiche_image---



;;---Dbut---------------------------------------------------Tal_change_Image----
;; << modifie le contour de l'image slectionne                               >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   16:49
;;
;; Admet : 
;; =======
;;   cle        : Chaine   = chaine d'entre
;;
;; Retourne : Entier = 
;; ==========
;-------------------------------------------------------------------------------
(Defun Tal_change_Image ( cle /  ncour)
     (setq ncour (substr cle 4))
     (Tal_Affiche_Image (itoa $typTal) nil)
     (Tal_Affiche_Image ncour T)
     (setq $TypTal (atoi ncour))
)
;;---fin-----------------------------------------------------Tal_change_Image----


 
;;---Dbut---------------------------------------------------Tal_Dial_Talus------
;; << Gestion de la case de dialogue                                           >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   16:55
;;
;; Admet : 
;; =======
;;
;; Retourne : Liste = (nb-d'esp  espacement  petit_trait grand-trait) ou 1
;; ==========
;-------------------------------------------------------------------------------
(Defun Tal_Dial_Talus ( / dclid linfo)
   (if (not (findfile $T_mess5))
     (alert $T_mess1)
   )  
   (setq dclid (load_dialog (findfile $T_mess5)))
   (if (new_dialog "dialtalus" dclid)
      (progn
        (foreach clef (list "ima1" "ima2" "ima3")
             (action_tile clef "(Tal_Change_Image $key)")
             (Tal_affiche_image (substr clef 4) (= (atoi (substr clef 4)) $typtal)) 
        )
        (mapcar '(lambda (clef valeur)
                     (set_tile clef (rtos valeur))  
                 )  
                 (list "pl" "gl" "esp")
                 (list $pltal $gltal $esptal)
    
        )
        (mode_tile "effac" (if (= 0 $encourstal) 1 0))
         
        (set_tile "nb" (itoa $nesptal))	
        (action_tile "accept" "(setq linfo (Tal_lit_dial))(done_dialog)")
        (action_tile "effac" "(setq linfo 1)(done_dialog)")
        (start_dialog)
      )
   )
   (unload_dialog dclid)
   linfo
)
;;---fin-----------------------------------------------------Tal_Dial_Talus------



;;---Dbut---------------------------------------------------Tal_Lit_Dial--------
;; << lit la case de dialogue                                                  >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   16:59
;;
;; Admet : 
;; =======
;;
;; Retourne : Liste = (nb-d'esp  espacement  petit_trait grand-trait)
;; ==========
;-------------------------------------------------------------------------------
(Defun Tal_Lit_Dial ( / )
    (list (atoi (get_tile "nb")) 
          (atof (get_tile "esp")) 
          (atof (get_tile "pl")) 
          (atof (get_tile "gl"))
    ) 
)
;;---fin-----------------------------------------------------Tal_Lit_Dial--------



;;---Dbut---------------------------------------------------T_Ext---------------
;; << extrait une information DXF de l'entit                                  >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:00
;;
;; Admet : 
;; =======
;;   clef       : Entier   = clef DXF
;;   ent        : Liste ou nom d'entit   = liste obtenue par Entget 
;;
;; Retourne : varie = valeur associe  la clef DXF
;; ==========
;-------------------------------------------------------------------------------
(Defun T_Ext ( clef ent / )
   (if (not (listp ent)) (setq ent (entget ent)))
   (cdr (assoc clef ent))
)
;;---fin---------------------------------------------------T_Ext---------------


 
;;---Dbut---------------------------------------------------Tal_OK--------------
;; << dfinit les points de base des hachures et le cot  et lance le trac    >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:03
;;
;; Admet : 
;; =======
;;
;; Retourne : Sans intrt = 
;; ==========
;-------------------------------------------------------------------------------
(Defun Tal_OK ( / e selpt lpt ptor pttenp ang selpt pttemp2 d ptx ptx1)
    (setq e (car (entsel $T_mess2)))
    (if (and e (member (t_ext 0 e) (list "POLYLINE" "LINE" "ARC" "CIRCLE" "LWPOLYLINE" "SPLINE"))) 
      (progn 
        (command "_undo" "_g")
        (command "_measure" e $esptal)
        (setq selpt (ssget "_P") n 0)
        (repeat (if selpt (sslength selpt) 0)
            (setq lpt (cons (trans (t_ext 10 (ssname selpt n)) 0 1) lpt) 
                  n (1+ n)
            )
        )
        (command "_undo" "_e")(command "_undo" 1)
        (setq ptx (nth (/ (length lpt) 2) lpt)
              ptx1 (nth (1+ (/ (length lpt) 2)) lpt)
        )
        (initget 1)
        (setq ptor (getpoint ptx $T_mess3)
              ang (angle ptx ptx1) 
              pttemp (inters ptx ptx1 
                             ptor (polar ptor (+ ang (/ pi 2)) 100)
                             nil
                     )
              d (distance ptor pttemp)
              pttemp2 (polar pttemp (+ ang (/ pi 2)) d)
              ang (if (equal ptor pttemp2 0.001) (/ pi 2) (/ pi -2))
        )
        (Tal_trace_talus lpt ang)
      )
    )
    
)
;;---fin-----------------------------------------------------Tal_OK--------------

 
;;---Dbut---------------------------------------------------Tal_Trace_Talus-----
;; << slectionne les pied de talus et lance la routine de trac               >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:06
;;
;; Admet : 
;; =======
;;   lpt        : Liste    = de points
;;   ang        : Rel     = direction des poils de talus
;;
;; Retourne : Entier = le nombre de talus trac : 1 ou 0
;; ==========
;-------------------------------------------------------------------------------
(Defun Tal_Trace_Talus ( lpt ang /  selpied x)
   (prompt (strcat $T_mess4 (if (= 1 $typtal) $T_mess6 " ")))
   (setq selpied (ssget))
   (cond
     ((= 1 $typtal) (talus1 lpt ang selpied))
     ((and selpied (= 2 $typtal)) (talus2 lpt ang selpied))
     ((and selpied (= 3 $typtal)) (talus3 lpt ang selpied))
     ((not selpied) (no_talus))
   ) 
)
;;---fin-----------------------------------------------------Tal_Trace_Talus-----


 
;;---Dbut---------------------------------------------------Talus1--------------
;; << calcul et lancement du trac d'un talus de type 1                        >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:09
;;
;; Admet : 
;; =======
;;   lpt        : Liste    = de points
;;   ang        : Rel     = direction
;;   selpied    :          = jeu de slection pied de talus
;;
;; Retourne : Entier = nombre de talus trac : 1
;; ==========
;-------------------------------------------------------------------------------
(Defun Talus1 ( lpt ang selpied /  n  pt pt1 pt2 ang1 long snap)
   (command "_undo" "_g")
   (setq n 0 sel nil snap (PutVar "osmode" 0)) 
   (repeat (- (length lpt) 1)
     (setq pt (nth n lpt) pt1 (nth (1+ n) lpt) ang1 (+ ang (angle pt pt1)))
     (setq long (if (zerop (rem n $nesptal)) $gltal $pltal))
     (command "_line" pt (setq pt2 (polar pt ang1 long)) "")
     (setq sel (cons (list (entlast) pt2) sel))
     (setq n (1+ n))
 
   )
   (setq long (if (zerop (rem n $nesptal)) $gltal $pltal))
   (command "_line" (last lpt) (setq pt2 (polar (last lpt) ang1 long)) "")
   (setq sel (cons (list (entlast) pt2) sel))
   (if selpied 
    (progn
     (command "_trim" selpied "")
     (foreach info sel (command info))
     (command "")
    )
   )
   (PutVar "osmode" snap) 
    (command "_undo" "_e")
  1
)
;;---fin-----------------------------------------------------Talus1--------------



;;---Dbut---------------------------------------------------Talus2--------------
;; << calcul et lancement du trac d'un talus de type 2                        >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:09
;;
;; Admet : 
;; =======
;;   lpt        : Liste    = de points
;;   ang        : Rel     = direction
;;   selpied    :          = jeu de slection pied de talus
;;
;; Retourne : Entier = nombre de talus trac : 1
;; ==========
;-------------------------------------------------------------------------------
(Defun Talus2 ( lpt ang selpied / n sel sel1 pt pt1 pt2 ang snap)
   (command "_undo" "_g")
   (setq n 0 sel nil sel1 nil snap (putvar "osmode" 0))
   (repeat (- (length lpt) 1)
     (setq pt (nth n lpt) pt1 (nth (1+ n) lpt) ang1 (+ ang (angle pt pt1)))
     (command "_line" pt (setq pt2 (polar pt ang1 $pltal)) "")
     (setq sel (cons (list (entlast) pt2) sel))
     (if (zerop (rem n $nesptal)) (setq sel1 (cons (car sel) sel1)))
     (setq n (1+ n))
 
   )
   (command "_line" (last lpt) (setq pt2 (polar (last lpt) ang1 $pltal)) "")
   (setq sel (cons (list (entlast) pt2) sel)) 
   (command "_extend" selpied "")
   (foreach info sel1 (command info))
   (command "")

   (command "_trim" selpied "")
   (foreach info sel (command info))
   (command "")
   (putvar "osmode" snap)

   (command "_undo" "_e")
   1
 )
;;---fin-----------------------------------------------------Talus2--------------



;;---Dbut---------------------------------------------------Talus3--------------
;; << calcul et lancement du trac d'un talus de type 3                        >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:09
;;
;; Admet : 
;; =======
;;   lpt        : Liste    = de points
;;   ang        : Rel     = direction
;;   selpied    :          = jeu de slection pied de talus
;;
;; Retourne : Entier = nombre de talus trac : 1
;; ==========
;-------------------------------------------------------------------------------
(Defun Talus3 ( lpt ang selpied / n sel sel1 pt pt1 pt2 ang snap)
   (command "_undo" "_g")
   (setq n 0 sel nil sel1 nil snap (putvar "osmode" 0))
   (repeat (- (length lpt) 1)
     (setq pt (nth n lpt) pt1 (nth (1+ n) lpt) ang1 (+ ang (angle pt pt1)))
     (if (zerop (rem n 2))
      (progn 
       (command "_line" pt (setq pt2 (polar pt ang1 0.001)) "")
       (setq sel (cons (list (entlast) pt2 n) sel))
      )
      (progn 
       (command "_line" pt (setq pt2 (polar pt ang1 $pltal)) "")
       (setq sel1 (cons (list (entlast) pt2) sel1))
      )
     ) 
     (setq n (1+ n))
 
   )
     (if (zerop (rem n 2))
      (progn 
       (command "_line" (last lpt) (setq pt2 (polar (last lpt) ang1 0.001)) "")
       (setq sel (cons (list (entlast) pt2 n) sel))
      )
      (progn 
       (command "_line" (last lpt) (setq pt2 (polar (last lpt) ang1 $pltal)) "")
       (setq sel1 (cons (list (entlast) pt2) sel1))
      )
     ) 
   (command "_trim" selpied "")
   (foreach info sel1 (command info))
   (command "")
   (Tal_exectalus3 sel selpied)
   (putvar "osmode" snap)
   (command "_undo" "_e")
   1
 )
;;---fin-----------------------------------------------------Talus3--------------


 
;;---Dbut---------------------------------------------------Tal_exectalus3------
;; << trace les traits tendus des talus de type 3                             >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:14
;;
;; Admet : 
;; =======
;;   sel        : Jeu de slection = traits  prolonger ventuellement
;;   selpied    : Jeu de slection = pieds de talus
;;
;; Retourne : Sans intrt = 
;; ==========
;-------------------------------------------------------------------------------
(Defun Tal_exectalus3 ( sel selpied / ent d1 d2 long ang p1 p2)
   (command "_extend" selpied "")
   (foreach info sel (command (list (car info) (cadr info))))
   (command "")
   (setq coef (/ $gltal $pltal)) 
   (foreach info sel
      (setq ent (entget (car info))
            puiss (tal_puis2 (caddr info))
            d1 (+ $pltal (* $gltal (tal_serie coef (- puiss 1))))
            d2 (+ $pltal (* $gltal (tal_serie coef puiss)))
            long (distance (t_ext 10 ent) (t_ext 11 ent))
            ang (angle (t_ext 10 ent) (t_ext 11 ent))
      )
      (if (> d1 long)
          (entdel (car info))
          (progn  
            (setq p1 (polar (t_ext 10 ent) ang d1))
            (if (> d2 long)
                (setq  p2 (t_ext 11 ent))
                (setq p2 (polar (t_ext 10 ent) ang d2))
            )
            (setq ent (subst (cons 10 p1) (assoc 10 ent) ent)
                  ent (subst (cons 11 p2) (assoc 11 ent) ent)  
            )
            (entmod ent)
          )
      ) 
   )
)
;;---fin-----------------------------------------------------Tal_exectalus3------



 
;;---Dbut---------------------------------------------------tal_no_talus--------
;; << message si pas de talus  tracer                                         >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:16
;;
;; Admet : 
;; =======
;;
;; Retourne : Entier = nombre de talus trac donc 0
;; ==========
;-------------------------------------------------------------------------------
(Defun tal_no_talus ( / )
   (alert "pour ce type de talus, vous devez dsigner \nau moins un pied de talus")
   0 
)
;;---fin-----------------------------------------------------tal_no_talus--------




 
;;---Dbut---------------------------------------------------chg_var-------------
;; << modifie une variable systme et rcupre sa valeur initiale              >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:18
;;
;; Admet : 
;; =======
;;   nom        : Chaine   = de la variable
;;   valeur     :          =  attacher  la variable
;;
;; Retourne : Entier = ancienne valeur
;; ==========
;-------------------------------------------------------------------------------
(Defun chg_var ( nom valeur /  xx)
   (setq xx (getvar nom))
   (setvar nom valeur)
   xx
)
;;---fin-----------------------------------------------------chg_var-------------

 
;;---Dbut---------------------------------------------------Tal_Cree_DCL--------
;; << crit le DCL                                                             >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:20
;;
;; Admet : 
;; =======
;;   option     : Boolen  = T : crit NIL met  0
;;
;; Retourne : Sans intrt = 
;; ==========
;-------------------------------------------------------------------------------
(Defun Tal_Cree_DCL ( option / fich)
  (setq fich (open "imtal.dcl" "w"))
  (if option
   (progn
    (write-line (strcat "imagetal:image_button {width = 20" (chr 59) 
                        "fixed_width = true"(chr 59) "aspect_ratio = 1"(chr 59) "}"
                ) fich
    )
    (write-line "lesimagestalus : column {" fich)
    (write-line (strcat "  : text {value = " (chr 34) "Offert par Didier-AD" (chr 34)(chr 59)"}") fich)
    (write-line "  :row {" fich)
    (write-line (strcat "    : imagetal {key=" (chr 34) "ima1" (chr 34) (chr 59) "}") fich) 
    (write-line (strcat "    : imagetal {key=" (chr 34) "ima2" (chr 34) (chr 59) "}") fich) 
    (write-line (strcat "    : imagetal {key=" (chr 34) "ima3" (chr 34) (chr 59) "}") fich) 
    (write-line "  }" fich)
    (write-line "}" fich)
   )
  )
  (setq fich (close fich))
)    
;;---fin-----------------------------------------------------Tal_Cree_DCL--------

 
;;---Dbut---------------------------------------------------Talerreur-----------
;; << gestion d'erreur                                                         >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:22
;;
;; Admet : 
;; =======
;;   ch         : Chaine   = message d'erreur
;;
;; Retourne : Sans intrt = 
;; ==========
;-------------------------------------------------------------------------------
(Defun Talerreur ( ch / )
  (Tal_cree_dcl nil)
  (setq *error* $olderr)
)
;;---fin-----------------------------------------------------Talerreur-----------

 
;;---Dbut---------------------------------------------------C:TALUS-------------
;; << commande principale                                                      >>
;; <<                                                                          >>
;;
;;  cre le :  samedi 21 novembre 1998   17:23
;;
;; Admet : 
;; =======
;;
;; Retourne : Sans intrt = 
;; ==========
;-------------------------------------------------------------------------------
(Defun tal_TALUS ( /  blp cmd linfo )
     (setq $encourstal 0)
     (setq $olderr *error* *error* talerreur)
     (setq cmd (chg_var "cmdecho" 0))
     (setq blp (chg_var "blipmode" 0))
     (setq linfo t)
     (while linfo
       (if (not $typtal) (setq $typtal 1))
       (if (not $esptal) (setq $esptal 2.0))
       (if (not $pltal) (setq $pltal 8.0))
       (if (not $gltal) (setq $gltal 15.0))
       (if (not $nesptal) (setq $nesptal 4))
       (setq oldtyp $typtal)
;       (Tal_cree_dcl T)
       (setq linfo (tal_dial_talus))
;      (tal_cree_dcl nil)
       (if (and linfo (listp linfo))
         (progn
           (setq  $nesptal (car linfo)
                 $esptal (cadr linfo)
                 $pltal (caddr linfo)
                 $gltal (cadddr linfo) 
           )          
           (setq $encourstal (+ (tal_OK) $encourstal))
         )
         (setq $typtal oldtyp)
       )
       (if (= 1 linfo) 
        (progn 
          (command "_undo" 1)
          (setq $encourstal (- $encourstal 1))
        )
       )
   )  
   (setq *error* $olderr $olderr nil)
   (setvar "cmdecho" cmd)
   (setvar "blipmode" blp)
)
;;---fin-----------------------------------------------------C:TALUS-------------


;;---Dbut---------------------------------------------------initialisation------
(if (wcmatch (strcase (getvar "LOCALE")) "FR*")
    (progn
      (defun c:talus () (tal_talus))
      (setq $T_mess1 "FDTALUS.DCL non trouv"
	    $T_mess2 "\nPointez la crte du talus "
	    $T_mess3 "\nCot des hachures "
	    $T_mess4 "\nSlectionnez le ou les pied(s) de talus "
	    $T_mess5  "FDTALUS.DCL"
	    $T_mess6  " (facultatif) "
	    tmp (alert "Tapez TALUS pour commencer")
      )
    )
    (progn
      (defun c:bank () (tal_talus))

      (setq $T_mess1 "EDTALUS.DCL not found"
	    $T_mess2 "\nPick the top of the bank "
	    $T_mess3 "\nSide for the hatch"
	    $T_mess4 "\nSelect the bottom of the bank "
	    $T_mess5 "EDTALUS.DCL"
	    $T_mess6 " (optional) "
	    c:bank c:talus
	    tmp (alert "Type BANK to begin")
      )
    )  
)
;;---Dbut---------------------------------------------------initialisation------
