(defun ex_xform (xpt matrix v / ex ey ez m1 m2 m3 m4 wx wy wz)
	(setq
		ex (car xpt)
		ey (cadr xpt)
		ez (caddr xpt)

		m1 (nth 0 matrix)
		m2 (nth 1 matrix)
		m3 (nth 2 matrix)

		wx (+
			(* (car m1) ex)
			(* (car m2) ey)
			(* (car m3) ez)
		)

		wy (+
			(* (cadr m1) ex)
			(* (cadr m2) ey)
			(* (cadr m3) ez)
		)

		wz (+
			(* (caddr m1) ex)
			(* (caddr m2) ey)
			(* (caddr m3) ez)
		)
	)
	(if (not v)
		(setq
			m4 (nth 3 matrix)
			wx (+ wx (car m4))
			wy (+ wy (cadr m4))
			wz (+ wz (caddr m4))
		)
	)
	(list wx wy wz)
)
(defun v_matr (dpt alphax alphay alphaz  echx echy echz / )
	(list
		(list
			(* echx (cos alphaz) (cos alphay))
			(- (sin alphaz))
			(sin alphay)
			(car dpt)
		)
		(list
			(sin alphaz)
			(* echy (cos alphaz) (cos alphax))
			(- (sin alphax))
			(cadr dpt)
		)
		(list
			(- (sin alphay))
			(sin alphax)
			(* echz (cos alphax) (cos alphay))
			(caddr dpt)
		)
;		(list 0.0 0.0 1.0 0.0)
		(list 0.0 0.0 0.0 1.0)
	)
)
(defun transpts (apt matrix)
	(list
		(+
			(* (car (nth 0 matrix)) (car apt))
			(* (car (nth 1 matrix)) (cadr apt))
			(* (car (nth 2 matrix)) (caddr apt))
			(cadddr (nth 0 matrix))
		)
		(+
			(* (cadr (nth 0 matrix)) (car apt))
			(* (cadr (nth 1 matrix)) (cadr apt))
			(* (cadr (nth 2 matrix)) (caddr apt))
			(cadddr (nth 1 matrix))
		)
		(+
			(* (caddr (nth 0 matrix)) (car apt))
			(* (caddr (nth 1 matrix)) (cadr apt))
			(* (caddr (nth 2 matrix)) (caddr apt))
			(cadddr (nth 2 matrix))
		)
	)
)
(defun c:model_hatch ( / zindim dec_prec ent ent_dxf nam_pat user_angle user_scale nbr_line dxf_line ang_motif n first_op transform pt_trans dlt_x dlt_y)
	(setvar "cmdecho" 0)
	(while (not (setq ent (entsel "\nChoix de la Hachure modle: "))))
	(initget 4)
	(setq dec_prec (getint "\nNombres de dcimales a afficher ?<8>: ") ent_dxf (entget (car ent)) zindim (getvar "dimzin"))
	(if (not dec_prec) (setq dec_prec 8))
	(setvar "dimzin" 12)
	(cond
		((eq (cdr (assoc 0 ent_dxf)) "HATCH")
			(setq
				nam_pat (strcat "\n*" (cdr (assoc 2 ent_dxf)))
				user_angle (cdr (assoc 52 ent_dxf))
				user_scale (cdr (assoc 41 ent_dxf))
				nbr_line (cdr (assoc 78 ent_dxf))
				dxf_line '()
				first_op T
			)
			(while (/= (caar ent_dxf) 53)
				(setq ent_dxf (cdr ent_dxf))
			)
(textscr)
(princ nam_pat)
			(repeat nbr_line
				(repeat 5
					(setq dxf_line (cons (cdar ent_dxf) dxf_line) ent_dxf (cdr ent_dxf))
					(if (eq (caar ent_dxf) 79)
						(progn
							(setq n (cdar ent_dxf) ent_dxf (cdr ent_dxf) dxf_line (cons nil dxf_line))
							(repeat n
								(setq dxf_line (cons (* (/ 1.0 user_scale) (cdar ent_dxf)) dxf_line) ent_dxf (cdr ent_dxf))
							)
						)
					)
				)
				(setq dxf_line (reverse dxf_line) ang_motif (car dxf_line) dxf_line (cdr dxf_line))
(princ (strcat "\n" (angtos (- ang_motif user_angle) 0 dec_prec)))
				(repeat (- (length dxf_line) (1+ n))
					(cond
						((not (car dxf_line))
							(setq dxf_line (cdr dxf_line))
							(while dxf_line
(princ (strcat "," (rtos (car dxf_line) 2 dec_prec)))
								(setq dxf_line (cdr dxf_line))
							)
						)
						(T
							(if first_op
								(setq transform (v_matr '(0.0 0.0 0.0) 0.0 0.0 user_angle 1.0 1.0 1.0) first_op nil)
								(setq transform (v_matr '(0.0 0.0 0.0) 0.0 0.0 ang_motif 1.0 1.0 1.0))
							)
							(setq
								pt_trans (transpts (list (* (/ 1.0 user_scale) (car dxf_line)) (* (/ 1.0 user_scale) (cadr dxf_line)) 0.0) transform)
								dlt_x (car pt_trans) dlt_y (cadr pt_trans)
								dxf_line (cons dlt_x (cons dlt_y (cddr dxf_line)))
							)
(princ (strcat "," (rtos (car dxf_line) 2 dec_prec) "," (rtos (cadr dxf_line) 2 dec_prec)))
							(setq dxf_line (cddr dxf_line))
						)
					)
				)
				(setq dxf_line '() first_op T)
			)
		)
		(T (prompt "\nEntit n'est pas une hachure."))
	)
	(setvar "dimzin" zindim)
	(setvar "cmdecho" 1)
	(prin1)
)