;;; PURGE_RASTER Supprime toutes les images raster du dessin dont le chemin n'est pas valide



(defun c:purge_raster (/ AcDoc n lay l_lst ss img pat)

  (vl-load-com)

  (setq AcDoc (vla-get-ActiveDocument (vlax-get-acad-object)))



  ;; Dvrouillage de tous les calques

  

  (repeat (setq n (vla-get-count (vla-get-Layers AcDoc)))

    (setq lay (vla-item (vla-get-Layers AcDoc) (setq n (1- n))))

    (if	(= :vlax-true

	   (vla-get-lock lay)

	)

      (progn

	(vla-put-lock lay :vlax-false)

	(setq l_lst (cons lay l_lst))

      )

    )

  )



  ;; Slection de toutes les images raster

  

  (setq ss (ssget "_X" '((0 . "IMAGE"))))

  

  ;; Suppression de celles qui ne sont pas rfrences

  

  (if ss

    (repeat (setq n (sslength ss))

      (setq img	(vlax-ename->vla-object (ssname ss (setq n (1- n))))

	    pat	(vla-get-ImageFile img)

      )

      (if (not (open pat "r"))

	(progn

	  (princ

	    (strcat "\nSuppression de l'image : " (vla-get-Name img))

	  )

	  (vla-delete img)

	)

      )

    )

  )



  ;; Restauration de l'tat des calques

  

  (if l_lst

    (mapcar '(lambda (x)

	       (vla-put-lock x :vlax-true)

	     )

	    l_lst

    )

  )

  (princ)

)